Codeforces 527C Glass Carving

  vjudge 上题目链接:Glass Carving

  题目大意: 一块 w * h 的玻璃,对其进行 n 次切割,每次切割都是垂直或者水平的,输出每次切割后最大单块玻璃的面积:

  

  用两个 set 存储每次切割的位置,就可以比较方便的把每次切割产生和消失的长宽存下来(用个 hash 映射数组记录下对应值的长宽的数量即可,O(1) 时间维护),每次切割后剩下的最大长宽的积就是答案了:

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<algorithm>
 4 #include<set>
 5 using namespace std;
 6 typedef long long LL;
 7 const int N = 200005;
 8
 9 int w[N], h[N];    // 记录存在的边长的数量
10 set<int> sw, sh;    // 记录下所有切点的位置
11 set<int>::iterator i,j;
12
13 void insert(set<int> &s, int *b, int p) {
14     s.insert(p);
15     i = j = s.find(p);
16     ++j;   --i;
17     --b[*j - *i];    // 除掉被分开的长宽
18     ++b[p - *i];    // 新产生了两个长宽
19     ++b[*j - p];
20 }
21
22 int main() {
23     int ww,hh,n,p;
24     while(~scanf("%d %d %d",&ww,&hh,&n)) {
25         sw.clear();   sh.clear();
26         sw.insert(0);    sw.insert(ww);
27         sh.insert(0);    sh.insert(hh);
28
29         memset(w, 0, sizeof w);     w[ww]++;
30         memset(h, 0, sizeof h);     h[hh]++;
31         int y = ww, x = hh;
32
33         while(n--) {
34             getchar();
35             if(getchar() == ‘H‘) {
36                 scanf("%d",&p);
37                 insert(sh, h, p);
38             }
39             else {
40                 scanf("%d",&p);
41                 insert(sw, w, p);
42             }
43             while(!w[y])    --y;    // 因为每次切割后最大值总是单调递减的,所以这样维护即可,如果从头到尾扫一遍的话会超时的
44             while(!h[x])    --x;
45             printf("%I64d\n", (LL)x * y);
46         }
47     }
48     return 0;
49 }

  参考了别人的思路才会做的,果然好强大,自己也好弱 Orz 。。。

时间: 2024-10-22 03:20:49

Codeforces 527C Glass Carving的相关文章

Codeforces 527C Glass Carving(Set)

题意  一块w*h的玻璃  对其进行n次切割  每次切割都是垂直或者水平的  输出每次切割后最大单块玻璃的面积 用两个set存储每次切割的位置   就可以比较方便的把每次切割产生和消失的长宽存下来  每次切割后剩下的最大长宽的积就是答案了 #include <bits/stdc++.h> using namespace std; const int N = 200005; typedef long long LL; set<int>::iterator i, j; set<i

Codeforces 527C Glass Carving (最长连续0变形+线段树)

Leonid wants to become a glass carver (the person who creates beautiful artworks by cutting the glass). He already has a rectangular w mm ?×? h mm sheet of glass, a diamond glass cutter and lots of enthusiasm. What he lacks is understanding of what t

Codeforces 528A Glass Carving STL模拟

题目链接:点击打开链接 题意: 给定n*m的矩阵,k个操作 2种操作: 1.H x 横向在x位置切一刀 2.V y 竖直在y位置切一刀 每次操作后输出最大的矩阵面积 思路: 因为行列是不相干的,所以只要知道每次操作后行的最大间距和列的最大间距,相乘就是最大面积 用一个set维护横向的所有坐标点,一个multiset维护横向的间距. 每次对行操作x则在set中找到比x大的最小数 r 和比x小的最大数l ,操作前的间距dis = r-l,在multiset中删除dis并插入r-x 和x-l.再在se

Codeforces 527A Glass Carving

题意:给你一张长方形的纸,你每一次撕掉最大的那个正方形,然后剩下来一块矩形,再继续对剩下的矩形进行这个操作,一直到这个剩下的矩形是个正方形. 解题思路:递归 解题代码: 1 // File Name: a.cpp 2 // Author: darkdream 3 // Created Time: 2015年03月18日 星期三 00时41分16秒 4 5 #include<vector> 6 #include<list> 7 #include<map> 8 #inclu

CF 527C Glass Carving

数据结构维护二维平面 首先横着切与竖着切是完全没有关联的, 简单贪心,最大子矩阵的面积一定是最大长*最大宽 此处有三种做法 1.用set来维护,每次插入操作寻找这个点的前驱和后继,并维护一个计数数组,来维护最大值 #include <iostream> #include <cstdio> #include <cstring> #include <algorithm> #include <cstring> #include <set>

C. Glass Carving (CF Round #296 (Div. 2) STL--set的运用)

C. Glass Carving time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Leonid wants to become a glass carver (the person who creates beautiful artworks by cutting the glass). He already has a re

Codeforces Round #296 (Div. 2) C. Glass Carving(想法题)

传送门 Description Leonid wants to become a glass carver (the person who creates beautiful artworks by cutting the glass). He already has a rectangular wmm  ×  h mm sheet of glass, a diamond glass cutter and lots of enthusiasm. What he lacks is understa

C. Glass Carving 正着做或者倒着做都可以

http://codeforces.com/problemset/problem/527/C 这题总体思路就是,每画一条线,然后就找到x间距的最max值和y间距的最max值,相乘就是当前的ans 那么我需要维护这样的一个数列,每次往里面添加一个元素,然后查询相邻两个元素的差值的最大值. 倒着做比较简单,首先把所有元素插上去,然后最大值直接暴力算一次.然后后来只有删除操作,这个操作只会让最大值变大. 每次删除后,检查上面和下面的新间距,和最大值比较一下就好. #include <bits/stdc

#296 (div.2) C.Glass Carving

1.题目描述:点击打开链接 2.解题思路:本题要求每切一刀,输出目前的最大玻璃的面积.这道题的思路很明显:每次切完后找目前的最大长度,最大宽度,相乘即可.不过问题的关键是如何快速的找到这个最大值. 一开始我没有太好的思路,想用数组,但总感觉数组力不从心,不知道怎么才能很好地更新切完后的长度值,也不知道如何快速的找到这个最大值.接着想到了STL中的set,可以把所有的切割位置存放在set中,然后逐个找最大值.不过这样的结果就是效率过低,导致TLE了.看了别人的代码才恍然大悟:可以直接除掉被切割的线